#include <stdio.h>
#include <pthread.h>

#define N 10
#define NTHREADS 2

double matrix[N][N];
double vectorX[N];
double vectorY[N];

void *mat_vec(void *arg)
{
	int i, j;
	int *p = (int *)arg;

	for(i=*p; i<N; i+=NTHREADS)
	{
		vectorY[i] = 0;
		for(j=0; j<N; j++)
			vectorY[i] += matrix[i][j]*vectorX[j];
	}

	return NULL;
}

int main(void)
{
	long i, j;
	pthread_t t[NTHREADS];
	int p[NTHREADS];

	for(i=0; i<N; i++)
	{
		vectorX[i] = 1.0;
		for(j=0; j<N; j++)
			matrix[i][j] = 1.0;
	}

	for(i=0; i<NTHREADS; i++)
	{
		p[i] = i;
		pthread_create(&t[i], NULL, mat_vec, (void *)&p[i]);
	}

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	for(i=0; i<N; i++)
		printf("%lf\n", vectorY[i]);

	return 0;
}
