// raunanje pi = 4*(1- 1/3 + 1/5 - 1/7 + ....)
// nitke, pravilen rezultat
// izraunavanje postane zelo poasno, e je tevilo niti veje od tevila procesorjev -
// nimamo vpliva na to, katero nit bo zagnal OS, mi pa zahtevamo, da se izmenjujejo
// v pravilnem vrstnem redu
// nit, ki aka v zanki while porablja procesorske vire
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <pthread.h>

#define N 1000
#define NTHREADS 5

double pi;
int lock;

void *thread_sum(void *arg)
{
	int i, sign;
	int rank = (int)arg;
	int start = (int)(N/(double)NTHREADS*rank);
	int stop = (int)(N/(double)NTHREADS*(rank+1));

	if( start%2 == 0)
		sign = 1;
	else 
		sign = -1;
	for(i=start; i<stop; i++, sign = -sign)
	{
		while( lock != rank );
		pi += sign*4.0/(2*i+1);
		lock = (lock+1)%NTHREADS;
	}

	return NULL;
}

int main(void)
{
	int i;
	pthread_t t[NTHREADS];

	pi = 0.0;

	for(i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, thread_sum, (void *)i);

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	printf("pi = %lf\n", pi);

	return 0;
}
